//+------------------------------------------------------------------+
//|                                                 Semen_Locals.mq4 |
//|                                                        			 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_color2 Aqua
#property indicator_color3 Aqua
#property indicator_color4 Aqua

extern int DaysCount = 20;
extern bool ShowLabels = false;

int StartHour;
int EndHour;

color UpColor = DarkBlue;
color DnColor = DarkBlue;
color TargetUpColor;
color TargetDnColor;

//---- buffers
double Up[];
double Down[];
double TargetUp[];
double TargetDn[];
bool Activate = False;
datetime LastDay;

bool StartDay = false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	TargetUpColor = UpColor;
	TargetDnColor = DnColor;
	SetIndexStyle(0,DRAW_LINE);
	SetIndexBuffer(0,Up);
	SetIndexStyle(1,DRAW_LINE);
	SetIndexBuffer(1,Down);
	SetIndexStyle(2,DRAW_LINE);
	SetIndexBuffer(2,TargetUp);
	SetIndexStyle(3,DRAW_LINE);
	SetIndexBuffer(3,TargetDn);
	SetIndexEmptyValue(0, 0.0);
	SetIndexEmptyValue(1, 0.0);
	SetIndexEmptyValue(2, 0.0);
	SetIndexEmptyValue(3, 0.0);
	
 	ArrayInitialize(Up,0);
	ArrayInitialize(Down,0);
	ArrayInitialize(TargetUp,0);
	ArrayInitialize(TargetDn,0);

	Activate = True;

return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	for (int i = ObjectsTotal()-1; i >= 0; i--)
 	{ 
  	string Name = ObjectName(i);
  	if (StringSubstr(Name, 0, 3) == "Lab")
    	ObjectDelete(Name);
 	}
	Comment("");
	return(0);
}

 void DrawLabel(datetime TimeL, double Price, bool Upper, color Col, int Code)
{
 if(Upper)
   string Name = "Lab"+DoubleToStr(TimeL, 0)+"U";
  else
   Name = "Lab"+DoubleToStr(TimeL, 0)+"D"; 

 if(ObjectCreate(Name, OBJ_ARROW, 0, TimeL, Price))
   {
    ObjectSet(Name, OBJPROP_ARROWCODE, Code);
    ObjectSet(Name, OBJPROP_COLOR, Col);
   } 
}


int start()
{
   if(!Activate) return(0);
   
   Comment( TimeToStr(Time[0],TIME_DATE|TIME_MINUTES) + "     " + TimeToStr(iTime(Symbol(),PERIOD_D1,0),TIME_DATE|TIME_MINUTES) );
   
   if ( Time[0] == iTime(Symbol(),PERIOD_D1,0))
   {
   	 StartDay = true;
   }
   
   if ( StartDay )
   {
   	 	ArrayInitialize(Up,0);
		ArrayInitialize(Down,0);
		ArrayInitialize(TargetUp,0);
		ArrayInitialize(TargetDn,0);
		StartDay = false;
   }

   LastDay = 0;
//   int counted_bars=IndicatorCounted();
//   if(counted_bars>0) counted_bars--;
//   int limit = (DaysCount-1)*(PERIOD_D1/Period()) - counted_bars;
   int limit = (DaysCount-1)*(PERIOD_D1/Period());

//   for(int i=limit; i>=0; i--)
 	 for(int i=limit; i>=0; i--)
     if(TimeHour(Time[i]) >= StartHour)
       {
         datetime BeginDay = iTime(Symbol(), PERIOD_D1, iBarShift(Symbol(), PERIOD_D1, Time[i]));
	     datetime NextDay = BeginDay+86400;
         if(LastDay >= BeginDay) continue; //       ,    
         int StartBar = iBarShift(Symbol(), PERIOD_H1, BeginDay+StartHour*3600);   // ,       
         int FinishBar = iBarShift(Symbol(), PERIOD_H1, BeginDay+(StartHour + 12)*3600); // ,    " "

         double LowV = iLow(Symbol(),PERIOD_H1,StartBar);  //  
         double HighV = iHigh(Symbol(),PERIOD_H1,StartBar);  

         StartBar = iBarShift(Symbol(), 0, BeginDay+StartHour*3600);   // ,       
         FinishBar = iBarShift(Symbol(), 0, BeginDay+(StartHour + 12)*3600); // ,    " "

         for(int j = StartBar; j >= FinishBar; j--)
           {
            Up[j] = HighV;
            Down[j] = LowV;
           }
         for(j = FinishBar+1; Time[j] < NextDay && j >= 0; j--)
           {
            TargetUp[j] = HighV;//TargetU;
            TargetDn[j] = LowV;//TargetD;
           }
           
		if ( ShowLabels )           
		{
         DrawLabel(Time[iBarShift(Symbol(), 0, BeginDay)], HighV, True, UpColor, 5);   //     
         DrawLabel(Time[iBarShift(Symbol(), 0, BeginDay)], LowV, False, DnColor, 5);   //     
		}
         LastDay = BeginDay;  // ,        
         
         
       }

   WindowRedraw();

   return(0);
  }
//+------------------------------------------------------------------+